xref: /haiku/configure (revision b5a871b1bf06bb62a4de95bcde6bdd748c0bfb8a)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
16e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
17e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
18e173a1ecSIngo Weinhold                              from the sources (in several phases).
19e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
20e173a1ecSIngo Weinhold                              suitable for the host platform.
21e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
22e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
23e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
24e173a1ecSIngo Weinhold                              HaikuPorts repository.
25c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
26338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
27338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
28338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
29a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
30a5b60fa8SOliver Tappe                              variables will be set accordingly.
3120ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
32c0e8cc1aSIngo Weinhold                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm",
33c0e8cc1aSIngo Weinhold                              or "mipsel".
34c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
35c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
36c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
37c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
38c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
39c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
40c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
41eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
42eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
43eccc7665SIngo Weinhold                              path to the directory where the cross
44eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
450da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
46eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
47a66c32ddSIngo Weinhold  --distro-compatibility <level>
48a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
49a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
50a66c32ddSIngo Weinhold                              files will contain the respective trademarks
51a66c32ddSIngo Weinhold                              accordingly.
52a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
53a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
54a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5560d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
56eccc7665SIngo Weinhold  --help                      Prints out this help.
572ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
582ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
592ebcd86dSIngo Weinhold                              this.
60eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6167838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6267838392SAxel Dörfler                              ideas and techniques. If this option is not
6367838392SAxel Dörfler                              specified, the resulting distribution may still
6467838392SAxel Dörfler                              implement patented ideas and techniques. This
6567838392SAxel Dörfler                              option only disables code that is currently known
6667838392SAxel Dörfler                              to be problematic.
6776fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6876fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6976fa0be3SIngo Weinhold                              patched sources. This is preferable when
7076fa0be3SIngo Weinhold                              distributing on physical mediums.
711974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
7260d8d8fcSIngo Weinhold  -j<n>                       Only relevant for --build-cross-tools and
7360d8d8fcSIngo Weinhold                              --build-cross-tools-gcc4. Is passed on to the
7460d8d8fcSIngo Weinhold                              make building the build tools.
757c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
767c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
77a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
78483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
79483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
80483b28e4SIngo Weinhold                              host system. The installed build tools for that
81483b28e4SIngo Weinhold                              architecture will be used.
82483b28e4SIngo Weinhold                              This option can be specified multiple times. The
83483b28e4SIngo Weinhold                              first occurrence specifies the primary
84483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
85483b28e4SIngo Weinhold                              ones the secondary architectures.
867c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
877c4641d0SOliver Tappe                              as first option!]
88eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
895a34a443SFrançois Revol                              process, but uses more memory.
90ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
91ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
920385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
93bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
94bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
95bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
96bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
97bc96e8f3SIngo Weinhold                              suffice).
98bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
99bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
100bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
101bc96e8f3SIngo Weinhold                              less likely).
102338b8dc3SIngo Weinhold
103338b8dc3SIngo Weinholdenvironment variables:
104c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
105c0e8cc1aSIngo Weinhold                              Defaults to "ar".
106c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
107c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
108c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
109c0e8cc1aSIngo Weinhold                              "objcopy".
110c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
111c0e8cc1aSIngo Weinhold                              to "ranlib".
112c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
11377e84f21SIngo Weinhold  HAIKU_YASM                  The yasm assembler (x86 only).
114c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
115c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
116c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
117c0e8cc1aSIngo Weinhold                              Defaults to "".
118c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
119c0e8cc1aSIngo Weinhold                              Defaults to "".
120c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
121c0e8cc1aSIngo Weinhold                              Defaults to "".
122c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
123c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
124c0e8cc1aSIngo Weinhold                              "cru".
125c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
126c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
127c0e8cc1aSIngo Weinhold                              "x".
12864f6da31SIngo Weinhold
129c0e8cc1aSIngo WeinholdNon-default output directories:
13064f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13164f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
13264f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
13364f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
13464f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
13564f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
13664f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
13764f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
13864f6da31SIngo Weinhold  non-default location and running jam.
13964f6da31SIngo Weinhold
14064f6da31SIngo Weinhold
141022fa244SIngo WeinholdEOF
142022fa244SIngo Weinhold}
143022fa244SIngo Weinhold
144022fa244SIngo Weinhold# assertparam
145022fa244SIngo Weinhold#
146022fa244SIngo Weinhold# Checks whether at least one parameter is left.
147022fa244SIngo Weinhold#
148022fa244SIngo Weinholdassertparam()
149022fa244SIngo Weinhold{
15020ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
151022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
152022fa244SIngo Weinhold		exit 1
153022fa244SIngo Weinhold	fi
154022fa244SIngo Weinhold}
155022fa244SIngo Weinhold
15620ab75e6SIngo Weinhold# assertparams
15720ab75e6SIngo Weinhold#
15820ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
15920ab75e6SIngo Weinhold#
16020ab75e6SIngo Weinholdassertparams()
16120ab75e6SIngo Weinhold{
16220ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
16320ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
16420ab75e6SIngo Weinhold		exit 1
16520ab75e6SIngo Weinhold	fi
16620ab75e6SIngo Weinhold}
16720ab75e6SIngo Weinhold
168e173a1ecSIngo Weinhold# absolute_path
169e173a1ecSIngo Weinhold#
170e173a1ecSIngo Weinhold# returns the absolute path of a given path.
171e173a1ecSIngo Weinhold#
172e173a1ecSIngo Weinholdabsolute_path()
173e173a1ecSIngo Weinhold{
1746a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
175e173a1ecSIngo Weinhold		echo "$1"
176e173a1ecSIngo Weinhold	else
177e173a1ecSIngo Weinhold		echo "`pwd`/$1"
178e173a1ecSIngo Weinhold	fi
179e173a1ecSIngo Weinhold}
180e173a1ecSIngo Weinhold
1819a001156SOliver Tappe# real_path
1829a001156SOliver Tappe#
1839a001156SOliver Tappe# returns the realpath of a symbolic link.
1849a001156SOliver Tappe#
1859a001156SOliver Tappereal_path()
1869a001156SOliver Tappe{
1879a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
1889a001156SOliver Tappe}
1899a001156SOliver Tappe
19009c5682dSIngo Weinhold# standard_gcc_settings
19109c5682dSIngo Weinhold#
19209c5682dSIngo Weinhold# Sets the variables for a GCC platform.
19309c5682dSIngo Weinhold#
19409c5682dSIngo Weinholdstandard_gcc_settings()
19509c5682dSIngo Weinhold{
196c0e8cc1aSIngo Weinhold	local gcc=$1
197c0e8cc1aSIngo Weinhold
198138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
199b29b48b1SMatt Madia		readlink="greadlink -e"
200138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
201b29b48b1SMatt Madia		readlink=realpath
2029a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
203b29b48b1SMatt Madia		readlink="readlink -e"
2049a001156SOliver Tappe	else
2059a001156SOliver Tappe		readlink=real_path
206b4b6d83cSMatt Madia	fi
207138f5fb4SIngo Weinhold
20809c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
209c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
210c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2115b0f7b1bSOliver Tappe
212c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
213c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
214338b8dc3SIngo Weinhold
215c0e8cc1aSIngo Weinhold	local libgcc=${gccdir}/libgcc.a
2168b5934c9SIngo Weinhold
217fc8967f1SIngo Weinhold	# determine architecture from machine triple
218c0e8cc1aSIngo Weinhold	case $gccMachine in
219c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
220c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
221c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
222c0e8cc1aSIngo Weinhold		mipsel-*)	targetCpu=mipsel;;
223c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
224c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
225fc8967f1SIngo Weinhold		*)
226c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
227fc8967f1SIngo Weinhold			exit 1
228fc8967f1SIngo Weinhold			;;
229fc8967f1SIngo Weinhold	esac
230fc8967f1SIngo Weinhold
231c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
232c0e8cc1aSIngo Weinhold	local staticLibStdCxx
233c0e8cc1aSIngo Weinhold	local sharedLibStdCxx
234c0e8cc1aSIngo Weinhold	local staticLibSupCxx
235c0e8cc1aSIngo Weinhold	local sharedLibSupCxx
236c0e8cc1aSIngo Weinhold	local kernelLibgcc
237c0e8cc1aSIngo Weinhold	local cxxHeaders
238fc8967f1SIngo Weinhold
239c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2408b5934c9SIngo Weinhold		4.*)
2415b0f7b1bSOliver Tappe			# for gcc 4 we use the libstdc++ and libsupc++ that come with the
2425b0f7b1bSOliver Tappe			# compiler
243c0e8cc1aSIngo Weinhold			staticLibStdCxx=`$gcc -print-file-name=libstdc++.a`
244c0e8cc1aSIngo Weinhold			sharedLibStdCxx=`$gcc -print-file-name=libstdc++.so`
245c0e8cc1aSIngo Weinhold			staticLibSupCxx=`$gcc -print-file-name=libsupc++.a`
246c0e8cc1aSIngo Weinhold			sharedLibSupCxx=`$gcc -print-file-name=libsupc++.so`
24714210488SMichael Lotz
248aaeadfcbSAlex Smith			# If the architecture has separate runtime libraries for the
249aaeadfcbSAlex Smith			# kernel, use them.
250c0e8cc1aSIngo Weinhold			kernelLibgcc=`$gcc -print-file-name=libgcc-kernel.a`
251c0e8cc1aSIngo Weinhold			if [ $kernelLibgcc = libgcc-kernel.a ]; then
252c0e8cc1aSIngo Weinhold				kernelLibgcc=$libgcc
253aaeadfcbSAlex Smith			fi
254c0e8cc1aSIngo Weinhold			kernelLibSupCxx=`$gcc -print-file-name=libsupc++-kernel.a`
255c0e8cc1aSIngo Weinhold			if [ $kernelLibSupCxx = libsupc++-kernel.a ]; then
256c0e8cc1aSIngo Weinhold				kernelLibSupCxx=$staticLibSupCxx
257aaeadfcbSAlex Smith			fi
258aaeadfcbSAlex Smith
259c0e8cc1aSIngo Weinhold			local headersBase=$gccdir/../../../..
260c0e8cc1aSIngo Weinhold			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
261c0e8cc1aSIngo Weinhold			if [ ! -d $headers ]; then
262c0e8cc1aSIngo Weinhold				headers=$headersBase/include/c++/$gccRawVersion
26314210488SMichael Lotz			fi
26414210488SMichael Lotz
265c0e8cc1aSIngo Weinhold			cxxHeaders=$headers
266c0e8cc1aSIngo Weinhold			for d in $gccMachine backward ext; do
26729ef597dSIngo Weinhold				# Note: We need the line break, otherwise the line might become
26829ef597dSIngo Weinhold				# too long for jam (512 bytes max).
269c0e8cc1aSIngo Weinhold				cxxHeaders="$cxxHeaders $headers/$d"
2708b5934c9SIngo Weinhold			done
271274b450aSMarcus Overhagen
2723f9f9f9aSIngo Weinhold			# Unset the HAIKU_{SHARED,STATIC}_LIB{STD,SUP}CXX variables, if the
2733f9f9f9aSIngo Weinhold			# compiler didn't give us actual file names. Otherwise resolve
2743f9f9f9aSIngo Weinhold			# symlinks to avoid problems when copying the libraries to the
2753f9f9f9aSIngo Weinhold			# image.
2768b5934c9SIngo Weinhold
277c0e8cc1aSIngo Weinhold			if [ $staticLibStdCxx = libstdc++.a ]; then
278c0e8cc1aSIngo Weinhold				staticLibStdCxx=
2793f9f9f9aSIngo Weinhold			else
280c0e8cc1aSIngo Weinhold				staticLibStdCxx=`$readlink $staticLibStdCxx`
2818b5934c9SIngo Weinhold			fi
2823f9f9f9aSIngo Weinhold
283c0e8cc1aSIngo Weinhold			if [ $sharedLibStdCxx = libstdc++.so ]; then
284c0e8cc1aSIngo Weinhold				sharedLibStdCxx=
2853f9f9f9aSIngo Weinhold			else
286c0e8cc1aSIngo Weinhold				sharedLibStdCxx=`$readlink $sharedLibStdCxx`
287ffe8b20cSIngo Weinhold			fi
2883f9f9f9aSIngo Weinhold
289c0e8cc1aSIngo Weinhold			if [ $staticLibSupCxx = libsupc++.a ]; then
290c0e8cc1aSIngo Weinhold				staticLibSupCxx=
2913f9f9f9aSIngo Weinhold			else
292c0e8cc1aSIngo Weinhold				staticLibSupCxx=`$readlink $staticLibSupCxx`
293c89fc875SIngo Weinhold			fi
2943f9f9f9aSIngo Weinhold
295c0e8cc1aSIngo Weinhold			if [ $sharedLibSupCxx = libsupc++.so ]; then
296c0e8cc1aSIngo Weinhold				sharedLibSupCxx=
2973f9f9f9aSIngo Weinhold			else
298c0e8cc1aSIngo Weinhold				sharedLibSupCxx=`$readlink $sharedLibSupCxx`
299ffe8b20cSIngo Weinhold			fi
3008b5934c9SIngo Weinhold			;;
3016cc8eecfSOliver Tappe		2.9*)
3025b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
3035b0f7b1bSOliver Tappe			# if an older one is installed
304c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
3055b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
3065b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
3075b0f7b1bSOliver Tappe				exit 1;
3085b0f7b1bSOliver Tappe			fi
309aaeadfcbSAlex Smith
310c0e8cc1aSIngo Weinhold			kernelLibgcc=$libgcc
311c0e8cc1aSIngo Weinhold			kernelLibSupCxx=
312c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
3135b0f7b1bSOliver Tappe			;;
3148b5934c9SIngo Weinhold	esac
31565ad1ba3SAlex Smith
316c0e8cc1aSIngo Weinhold	local bootLibgcc
317c0e8cc1aSIngo Weinhold	local bootLibSupCxx
318c0e8cc1aSIngo Weinhold	case $gccMachine in
3194591ebc9SAlex Smith		x86_64-*)
320c864ba1aSAlex Smith			# Boot loader is 32-bit, need the 32-bit libs.
321c0e8cc1aSIngo Weinhold			bootLibgcc=`$gcc -m32 -print-libgcc-file-name`
322c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
3234591ebc9SAlex Smith			;;
3244591ebc9SAlex Smith		*)
325c0e8cc1aSIngo Weinhold			bootLibgcc=$libgcc
326c0e8cc1aSIngo Weinhold			bootLibSupCxx=$staticLibSupCxx
327338b8dc3SIngo Weinhold			;;
328338b8dc3SIngo Weinhold	esac
329c0e8cc1aSIngo Weinhold
330c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
331c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
332c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
333c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
334c0e8cc1aSIngo Weinhold	fi
335c0e8cc1aSIngo Weinhold
336c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
337c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
338c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
339c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
340c0e8cc1aSIngo Weinhold			useGraphite=0
341c0e8cc1aSIngo Weinhold		fi
342c0e8cc1aSIngo Weinhold	fi
343c0e8cc1aSIngo Weinhold
344c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
345c0e8cc1aSIngo Weinhold
346c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
347c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
348c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
349c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
350c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIBGCC_$targetArch $libgcc
351c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_GLUE_CODE_$targetArch "crtbegin.o crtend.o"
352c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_HEADERS_DIR_$targetArch \
353c0e8cc1aSIngo Weinhold		"${gccdir}/include ${gccdir}/include-fixed"
354c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSTDCXX_$targetArch "$staticLibStdCxx"
355c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSTDCXX_$targetArch "$sharedLibStdCxx"
356c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSUPCXX_$targetArch "$staticLibSupCxx"
357c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSUPCXX_$targetArch "$sharedLibSupCxx"
358c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBSUPCXX_$targetArch "$kernelLibSupCxx"
359c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
360c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBGCC_$targetArch $kernelLibgcc
361c0e8cc1aSIngo Weinhold	set_variable HAIKU_CXX_HEADERS_DIR_$targetArch "$cxxHeaders"
362c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
363c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
364c0e8cc1aSIngo Weinhold
365c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
366c0e8cc1aSIngo Weinhold}
367c0e8cc1aSIngo Weinhold
368c0e8cc1aSIngo Weinhold# set_variable
369c0e8cc1aSIngo Weinhold#
370c0e8cc1aSIngo Weinhold# Set the value of a variable.
371c0e8cc1aSIngo Weinhold#
372c0e8cc1aSIngo Weinholdset_variable()
373c0e8cc1aSIngo Weinhold{
374c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
375c0e8cc1aSIngo Weinhold}
376c0e8cc1aSIngo Weinhold
377c0e8cc1aSIngo Weinhold# get_variable
378c0e8cc1aSIngo Weinhold#
379c0e8cc1aSIngo Weinhold# Echo the value of a variable.
380c0e8cc1aSIngo Weinhold#
381c0e8cc1aSIngo Weinholdget_variable()
382c0e8cc1aSIngo Weinhold{
383c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
38409c5682dSIngo Weinhold}
38509c5682dSIngo Weinhold
386338b8dc3SIngo Weinhold# set_default_value
387338b8dc3SIngo Weinhold#
388338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
389338b8dc3SIngo Weinhold#
390338b8dc3SIngo Weinholdset_default_value()
391338b8dc3SIngo Weinhold{
392338b8dc3SIngo Weinhold	eval "$1=\${$1-$2}"
393338b8dc3SIngo Weinhold}
394338b8dc3SIngo Weinhold
395338b8dc3SIngo Weinhold# get_build_tool_path
396338b8dc3SIngo Weinhold#
397338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
398338b8dc3SIngo Weinhold#
399338b8dc3SIngo Weinholdget_build_tool_path()
400338b8dc3SIngo Weinhold{
401338b8dc3SIngo Weinhold	local var="HAIKU_$1"
402c0e8cc1aSIngo Weinhold	local path=$2
403338b8dc3SIngo Weinhold
404338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
405338b8dc3SIngo Weinhold		# get absolute path
406a559f87aSFrançois Revol		local oldPwd="`pwd`"
407a559f87aSFrançois Revol		cd "`dirname "$path"`"
408a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
409338b8dc3SIngo Weinhold		cd $oldPwd
410338b8dc3SIngo Weinhold	else
4117fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
412338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
413338b8dc3SIngo Weinhold			exit 1
414338b8dc3SIngo Weinhold		}
415338b8dc3SIngo Weinhold	fi
416338b8dc3SIngo Weinhold
417338b8dc3SIngo Weinhold	eval "$var=$path"
418338b8dc3SIngo Weinhold}
419338b8dc3SIngo Weinhold
420483b28e4SIngo Weinholdis_in_list()
421483b28e4SIngo Weinhold{
422483b28e4SIngo Weinhold	local element
423483b28e4SIngo Weinhold	for element in $2; do
424483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
425483b28e4SIngo Weinhold			return 0
426483b28e4SIngo Weinhold		fi
427483b28e4SIngo Weinhold	done
428483b28e4SIngo Weinhold	return 1
429483b28e4SIngo Weinhold}
430483b28e4SIngo Weinhold
431338b8dc3SIngo Weinhold# get cwd and the source directory
432338b8dc3SIngo WeinholdcurrentDir=`pwd`
4336e7c6fe5SIngo Weinholdcd `dirname "$0"`
434338b8dc3SIngo WeinholdsourceDir=`pwd`
4356e7c6fe5SIngo Weinholdcd "$currentDir"
436338b8dc3SIngo Weinhold
43755d267a4SFrançois Revol# backup the passed arguments
43855d267a4SFrançois RevolconfigureArgs="$@"
43955d267a4SFrançois Revol
4407c4641d0SOliver Tappe# internal default parameter values
441022fa244SIngo Weinhold#
44252a38012Sejakowatzplatform=`uname`
4435abd9a46SIngo WeinholdplatformMachine=`uname  -m`
444c0e8cc1aSIngo WeinholdtargetArchs=
445338b8dc3SIngo WeinholdbuildCrossTools=
44629ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
44760d8d8fcSIngo WeinholdbuildCrossToolsJobs=
448c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
449c0e8cc1aSIngo WeinholdunknownArchIndex=1
450483b28e4SIngo WeinholdhaikuTargetArchs=
4517c4641d0SOliver Tappe
4527c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4537c4641d0SOliver Tappe#
4547c4641d0SOliver TappeHOST_GCC_RAW_VERSION=`gcc -dumpversion`
4557c4641d0SOliver TappeHOST_GCC_MACHINE=`gcc -dumpmachine`
4567c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
4577c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
45876fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4597c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4607c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4617c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4627c4641d0SOliver TappeTARGET_PLATFORM=haiku
4637c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4647986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4657986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
466bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4672ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
4687c4641d0SOliver TappeHOST_GCC_LD=`gcc -print-prog-name=ld`
4697c4641d0SOliver TappeHOST_GCC_OBJCOPY=`gcc -print-prog-name=objcopy`
470c505b276SFrançois RevolSFDISK_BINARY=sfdisk
471c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
4722a5d0aafSIngo WeinholdHOST_SHA256=
473e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
474e173a1ecSIngo WeinholdHAIKU_PORTS=
475e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
4762a5d0aafSIngo Weinhold
477c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
478c0e8cc1aSIngo Weinhold
479c0e8cc1aSIngo Weinholdset_default_value HAIKU_YASM		yasm
480c0e8cc1aSIngo Weinhold
4813942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4822a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4833942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4842a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
485*b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
486*b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4872a5d0aafSIngo Weinholdelse
4882a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
4892a5d0aafSIngo Weinhold	exit 1
4902a5d0aafSIngo Weinholdfi
491338b8dc3SIngo Weinhold
492cc91b333SIngo WeinholdhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2013_08_15"
493a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
494af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
495483b28e4SIngo WeinholdsupportedTargetArchs="
496483b28e4SIngo Weinhold	arm
497483b28e4SIngo Weinhold	m68k
498483b28e4SIngo Weinhold	mipsel
499483b28e4SIngo Weinhold	ppc
500483b28e4SIngo Weinhold	x86
501483b28e4SIngo Weinhold	x86_64
502483b28e4SIngo Weinhold	x86_gcc2
503483b28e4SIngo Weinhold	"
504af4bf973SOliver Tappe
5057c4641d0SOliver Tappe# determine output directory
5067c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
5077c4641d0SOliver Tappe	outputDir=$currentDir/generated
5087c4641d0SOliver Tappeelse
5097c4641d0SOliver Tappe	outputDir=$currentDir
5107c4641d0SOliver Tappefi
5117c4641d0SOliver TappebuildOutputDir="$outputDir/build"
5127c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
5137c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5147c4641d0SOliver Tappe
5157c4641d0SOliver Tappe# check for update request
5167c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5177c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5187c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5197c4641d0SOliver Tappe		exit 1
5207c4641d0SOliver Tappe	fi
5217c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5227c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5237c4641d0SOliver Tappe		exit 1
5247c4641d0SOliver Tappe	fi
5257c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5267c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5277c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5287c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5297c4641d0SOliver Tappe	. "$shellConfigFile"
5307c4641d0SOliver Tappe	rm "$shellConfigFile"
5317c4641d0SOliver Tappe	shift
5327c4641d0SOliver Tappefi
5337c4641d0SOliver Tappe
534022fa244SIngo Weinhold# parse parameters
535022fa244SIngo Weinhold#
53620ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
537022fa244SIngo Weinhold	case "$1" in
538e173a1ecSIngo Weinhold		--bootstrap)
539e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
540e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
541e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
542e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
543e173a1ecSIngo Weinhold			shift 4
544e173a1ecSIngo Weinhold			;;
545c0e8cc1aSIngo Weinhold		--build-cross-tools)
546c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5479b0dd528SIngo Weinhold				assertparams "$1" 2 $#
548c0e8cc1aSIngo Weinhold				targetArch=$2
5499b0dd528SIngo Weinhold				buildCrossTools=$3
5509b0dd528SIngo Weinhold				shift 3
551c0e8cc1aSIngo Weinhold			else
552c0e8cc1aSIngo Weinhold				assertparam "$1" $#
553c0e8cc1aSIngo Weinhold				targetArch=$2
554c0e8cc1aSIngo Weinhold				shift 2
555c0e8cc1aSIngo Weinhold			fi
556c0e8cc1aSIngo Weinhold			case "$targetArch" in
557c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
558c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
559c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
560c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
561c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
562c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
563c0e8cc1aSIngo Weinhold				mipsel)		targetMachine=mipsel-unknown-haiku;;
564c0e8cc1aSIngo Weinhold				*)
565c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
566c0e8cc1aSIngo Weinhold					exit 1
567c0e8cc1aSIngo Weinhold					;;
568c0e8cc1aSIngo Weinhold			esac
569c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
570c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
571c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5729b0dd528SIngo Weinhold			;;
5739b0dd528SIngo Weinhold		--cross-tools-prefix)
5749b0dd528SIngo Weinhold			assertparam "$1" $#
575c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
576c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
577c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
578c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
579d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5809b0dd528SIngo Weinhold			shift 2
5819b0dd528SIngo Weinhold			;;
582a66c32ddSIngo Weinhold		--distro-compatibility)
5839b0dd528SIngo Weinhold			assertparam "$1" $#
5847c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5857c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
586a66c32ddSIngo Weinhold				official)	;;
587a66c32ddSIngo Weinhold				compatible)	;;
588a66c32ddSIngo Weinhold				default)	;;
589a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
5907c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
591a66c32ddSIngo Weinhold							exit 1;;
592a66c32ddSIngo Weinhold			esac
5939b0dd528SIngo Weinhold			shift 2
5949b0dd528SIngo Weinhold			;;
5957c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
59660d8d8fcSIngo Weinhold		--help | -h)	usage; exit 0;;
5972ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
5987c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
5997c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
60076fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
6017c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
60260d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
6037c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
604483b28e4SIngo Weinhold		--target-arch)
605483b28e4SIngo Weinhold			assertparam "$1" $#
606483b28e4SIngo Weinhold			targetArch=$2
607483b28e4SIngo Weinhold			shift 2
608483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
609483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
610483b28e4SIngo Weinhold				exit 1
611483b28e4SIngo Weinhold			fi
612483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
613483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
614483b28e4SIngo Weinhold				exit 1
615483b28e4SIngo Weinhold			)
616483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
617483b28e4SIngo Weinhold			;;
6187c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
619c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6207986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6217986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
622bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
623022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
624022fa244SIngo Weinhold	esac
625022fa244SIngo Weinholddone
626022fa244SIngo Weinhold
6270df3cc9cSIngo Weinhold# detect the build platform
628338b8dc3SIngo Weinholdcase "${platform}" in
6297c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6307c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
631c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
6327986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6335abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
634308c212cSIngo Weinhold					exit 1
635308c212cSIngo Weinhold				fi	;;
6367c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6377c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6387c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6397c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6407c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
641338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6424cbe4925SAxel Dörfler			exit 1 ;;
6434cbe4925SAxel Dörfleresac
64452a38012Sejakowatz
645c505b276SFrançois Revol# check common locations for sfdisk
646c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
647c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
648c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
649c505b276SFrançois Revol	fi
650c505b276SFrançois Revoldone
651c505b276SFrançois Revol
6520962132cSAlex Smith# check for case-sensitive filesystem
6530962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6540962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6550962132cSAlex SmithcaseInsensitive=$?
65697f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6570962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6583ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6590962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6600962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
6610962132cSAlex Smith		echo "it to store the Haiku sources on."
6623ecc5287SMichael Lotz	fi
6630962132cSAlex Smith	exit 1
6643ecc5287SMichael Lotzfi
6653ecc5287SMichael Lotz
666338b8dc3SIngo Weinhold# create output directory
6676e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
668338b8dc3SIngo Weinhold
6692ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6702ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6712ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6722ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6732ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6742ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6752ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6762ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
6772ebcd86dSIngo Weinhold	HAIKU_YASM=$invalidCommand
6782ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6792ebcd86dSIngo Weinholdelse
680c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
681c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
682c0e8cc1aSIngo Weinhold	fi
683c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
684c0e8cc1aSIngo Weinhold
685483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
686c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
687483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
688483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
689483b28e4SIngo Weinhold				"--cross-tools-prefix or --build-cross-tools) or specify a"
690483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
691483b28e4SIngo Weinhold			exit 1
692483b28e4SIngo Weinhold		fi
693483b28e4SIngo Weinhold
694483b28e4SIngo Weinhold		# determine primary architecture
695483b28e4SIngo Weinhold		targetArch=`package list -i /system/packages/haiku.hpkg \
696483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
697483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
698483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
699483b28e4SIngo Weinhold			exit 1
700483b28e4SIngo Weinhold		)
701c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
702483b28e4SIngo Weinhold
703c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
704c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
705c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
706c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
707c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
708c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
709c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
710483b28e4SIngo Weinhold
711483b28e4SIngo Weinhold		# determine secondary architectures
712483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
713483b28e4SIngo Weinhold			if [ -e /system/packages/haiku_$targetArch.hpkg ]; then
714483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
715483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
716483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
717483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
718483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
719483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
720483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
721483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
722483b28e4SIngo Weinhold			fi
723483b28e4SIngo Weinhold		done
724483b28e4SIngo Weinhold
725483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
726483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
727483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
728483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
729483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
730483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
731483b28e4SIngo Weinhold						"be specified." >&2
732483b28e4SIngo Weinhold					exit 1
733483b28e4SIngo Weinhold				)
734483b28e4SIngo Weinhold			done
735483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
736483b28e4SIngo Weinhold		fi
737c0e8cc1aSIngo Weinhold	fi
738c0e8cc1aSIngo Weinhold
73968ccc989SIngo Weinhold	isPrimaryArch=1
740c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
741c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
742c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
743c0e8cc1aSIngo Weinhold		# the actual architecture.
744c0e8cc1aSIngo Weinhold
745c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
746c0e8cc1aSIngo Weinhold
747338b8dc3SIngo Weinhold		# build cross tools from sources
748c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
749c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
750c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
751c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
752c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
753c0e8cc1aSIngo Weinhold				script="${script}_gcc4 $targetMachine"
754c0e8cc1aSIngo Weinhold			fi
75568ccc989SIngo Weinhold			secondaryArch=
75668ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
75768ccc989SIngo Weinhold				secondaryArch=$targetArch
75868ccc989SIngo Weinhold			fi
75986de8c37SIngo Weinhold
76086de8c37SIngo Weinhold			case $HOST_PLATFORM in
76186de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
76286de8c37SIngo Weinhold				*)					MAKE=make;;
76386de8c37SIngo Weinhold			esac
76486de8c37SIngo Weinhold
76586de8c37SIngo Weinhold			MAKE=$MAKE \
76668ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
767c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
768c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
769c0e8cc1aSIngo Weinhold			$script "$sourceDir" "$buildCrossTools" "$crossToolsDir" \
770c0e8cc1aSIngo Weinhold				$buildCrossToolsJobs || exit 1
771c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
772338b8dc3SIngo Weinhold		fi
773338b8dc3SIngo Weinhold
774c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
775c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
776c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
777c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
778338b8dc3SIngo Weinhold		fi
779c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
780c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
781338b8dc3SIngo Weinhold
782c0e8cc1aSIngo Weinhold		# set default values for flags
783c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
784c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
785c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
786c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
787c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
788c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
789338b8dc3SIngo Weinhold
790c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
791c0e8cc1aSIngo Weinhold		# prefix was specified.
792b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
793c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
794c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
795c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
796c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
797c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
798c0e8cc1aSIngo Weinhold
799c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
800bd16f0ddSAlex Smith				4.*)
801c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
802c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
803bd16f0ddSAlex Smith				;;
804bd16f0ddSAlex Smith			esac
80552a38012Sejakowatz		fi
80652a38012Sejakowatz
807c0e8cc1aSIngo Weinhold		# Get the libgcc objects. We couldn't do that in standard_gcc_settings,
808c0e8cc1aSIngo Weinhold		# since we need "ar", which may be set later.
809c0e8cc1aSIngo Weinhold		ar=`get_variable HAIKU_AR_$targetArch`
810c0e8cc1aSIngo Weinhold		libgcc=`get_variable HAIKU_GCC_LIBGCC_$targetArch`
811c0e8cc1aSIngo Weinhold		set_variable HAIKU_GCC_LIBGCC_OBJECTS_$targetArch \
812c0e8cc1aSIngo Weinhold			"`$ar t $libgcc | grep -v eabi.o`"
813c0e8cc1aSIngo Weinhold			# Note: We filter out eabi.o. It's present in gcc's libgcc for PPC
814c0e8cc1aSIngo Weinhold			# and neither needed nor wanted.
815c0e8cc1aSIngo Weinhold
816ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
817c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
818c0e8cc1aSIngo Weinhold		case "$targetMachine" in
819eedc3d0bSIngo Weinhold			*-*-haiku)	;;
820c0e8cc1aSIngo Weinhold			*)
821c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
822c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
823eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
824c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
825eedc3d0bSIngo Weinhold				exit 1 ;;
826eedc3d0bSIngo Weinhold		esac
827c0e8cc1aSIngo Weinhold
828c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
82968ccc989SIngo Weinhold		isPrimaryArch=
830c0e8cc1aSIngo Weinhold	done
8312ebcd86dSIngo Weinholdfi
832eedc3d0bSIngo Weinhold
83352a38012Sejakowatz# Generate BuildConfig
8347c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
83552a38012Sejakowatz# BuildConfig
836ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
837ab2540c4SIngo Weinhold# following arguments:
83855d267a4SFrançois Revol# ${configureArgs}
83952a38012Sejakowatz
8407c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8417c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
842338b8dc3SIngo Weinhold
8437c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
8447c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
84576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8467c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8477c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8487c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8497c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8507986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8517986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
852bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8532ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
854eccc7665SIngo Weinhold
855c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
85665ad1ba3SAlex Smith
8577c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
858338b8dc3SIngo Weinhold
85977e84f21SIngo WeinholdHAIKU_YASM					?= ${HAIKU_YASM} ;
860338b8dc3SIngo Weinhold
8617c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8627c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8637c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8647c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
865c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
8662a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8678b5934c9SIngo Weinhold
868e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
869e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
870e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
871e173a1ecSIngo Weinhold
872c4786ea6SlilloEOF
873c4786ea6Slillo
874c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
875c0e8cc1aSIngo Weinhold	variables="
876c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
877c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
878c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
879c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC			HAIKU_GCC_LIBGCC
880c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
881c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSTDC++		HAIKU_STATIC_LIBSTDCXX
882c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSTDC++		HAIKU_SHARED_LIBSTDCXX
883c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSUPC++		HAIKU_STATIC_LIBSUPCXX
884c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSUPC++		HAIKU_SHARED_LIBSUPCXX
885c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBGCC			HAIKU_KERNEL_LIBGCC
886c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBSUPC++		HAIKU_KERNEL_LIBSUPCXX
887c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
888c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
889c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
890c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
891c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
892c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
893c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
894c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
895c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
896c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
897c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
898c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
899c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
900c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
901c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
902c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
903c0e8cc1aSIngo Weinhold		"
904c0e8cc1aSIngo Weinhold	set -- $variables
905c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
906c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
907c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
908c0e8cc1aSIngo Weinhold		shift 2
909c0e8cc1aSIngo Weinhold	done
910b1e5b60cSAxel Dörfler
911c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
912c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
913c0e8cc1aSIngo Weinhold	variables="
914c0e8cc1aSIngo Weinhold		HAIKU_GCC_HEADERS_DIR		HAIKU_GCC_HEADERS_DIR
915c0e8cc1aSIngo Weinhold		HAIKU_C++_HEADERS_DIR		HAIKU_CXX_HEADERS_DIR
916c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC_OBJECTS	HAIKU_GCC_LIBGCC_OBJECTS
917c0e8cc1aSIngo Weinhold		"
918c0e8cc1aSIngo Weinhold	set -- $variables
919c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
920c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
921c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
922c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
923c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
924c0e8cc1aSIngo Weinhold		shift 2
925c0e8cc1aSIngo Weinhold	done
926c0e8cc1aSIngo Weinholddone
927b1e5b60cSAxel Dörfler
928b1e5b60cSAxel Dörfler
9299b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
930338b8dc3SIngo Weinhold
931338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
932338b8dc3SIngo Weinhold# automatically generated Jamfile
933338b8dc3SIngo Weinhold
934338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
935338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
936338b8dc3SIngo Weinhold
937338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
938338b8dc3SIngo Weinhold
939338b8dc3SIngo WeinholdEOF
940